/*
 * RTLinux Hello World example
 *
 * Written by Michael Barabanov (baraban@fsmlabs.com)
 * Copyright (C) 1999-2000 VJY Associates LLC
 * Released under the terms of the GPL
 *
 */

#include <rtl.h>
#include <time.h>
#include <pthread.h>

#include <rtl_debug.h>

pthread_t thread;

void * start_routine(void *arg)
{
	int i;
	struct sched_param p;
	p . sched_priority = 1;
	pthread_setschedparam (pthread_self(), SCHED_FIFO, &p);

	pthread_make_periodic_np (pthread_self(), gethrtime(), 500000000);

	breakpoint();

	for (i = 0; i < 20; i ++) {
		pthread_wait_np ();
		rtl_printf("I'm here; my arg is %x\n", (unsigned) arg);
	}
	return 0;
}

int init_module(void) {
	return pthread_create (&thread, NULL, start_routine, 0);
}

void cleanup_module(void) {
	pthread_delete_np (thread);
}
