/*
 * RT-Linux debug routines
 *
 * Written by Michael Barabanov
 * Copyright (C) VJY Associates LLC, 1998-1999
 * Released under the terms of the GPL
 *
 * Idea from include/linux/sunrpc/debug.h
 * Copyright (C) 1996, Olaf Kirch <okir@monad.swb.de>
 *
 */

#ifndef __RTL_DEBUG__
#define __RTL_DEBUG__


#define do_times(x) { static count=x; while (count-- > 0) {
#define end_do_times() }}

#define do_every(x) do { static count=x; if (!(count++ % x))
#define end_do_every } while (0)

#ifdef __KERNEL__

#ifdef RTL_DEBUG_PRINT
#define debugpr(format, args...)	rtl_cprintf(format, ## args)
#else
#define debugpr(format, args...)	do { ; } while (0)
#endif

extern void breakpoint(void);

#ifdef __i386__
#define BREAKPOINT() asm("   int $3");
#else 
#define BREAKPOINT() do { ; } while (0)
#endif

/* This will generate a breakpoint exception.  It can be used at the
   beginning of a program to sync up with a debugger and can be used
   otherwise as a quick means to stop program execution and "break" into
   the debugger. */

extern int rtl_debug_initialized;
#define breakpoint() do { if (rtl_debug_initialized) BREAKPOINT(); } while (0)

#endif /* __KERNEL__ */


#endif /* __RTL_DEBUG__ */

