/*
 * RT-Linux waitqueue implementation
 *
 * Written by Michael Barabanov
 * Copyright (C) VJY Associates LLC, 1999
 * Released under the terms of the GPL
 *
 */


#ifndef __RTL_WAITQUEUE__
#define __RTL_WAITQUEUE__

#define RTL_MAX_WQ_THREADS 20

struct rtl_wq_struct {
	int nqueued;
	RTL_THREAD_STRUCT *threads[RTL_MAX_WQ_THREADS];
};

#define RTL_WQ_INITIALIZER { 0 }

typedef struct rtl_wq_struct RTL_WQ;

extern inline int rtl_wq_init (RTL_WQ *q)
{
	q->nqueued = 0;
	return 0;
}

/* TODO implement priority-based insert/remove */
extern inline int rtl_wq_insert(RTL_WQ *q, RTL_THREAD_STRUCT *t)
{
	if (q->nqueued >= RTL_MAX_WQ_THREADS) {
		return EAGAIN;
	}
	q->threads [q->nqueued++] = t;
	return 0;
}

extern inline RTL_THREAD_STRUCT *rtl_wq_remove(RTL_WQ *q)
{
	if (q->nqueued == 0) {
		return 0;
	}
	return q->threads [--q->nqueued];
}


#endif

